#include xl97cons.h
SET TALK OFF
SET TEXTMERGE ON NOSHOW    && Enable embedding of expressions and functions
IF FILE('INIT.txt')
	FCLOSE(_TEXT )
	ERASE 'INIT.txt'
ENDIF
STORE FCREATE('INIT.txt') TO _TEXT     && Create low-level file
IF _TEXT = -1  && Can't create low-level file then exit program
	WAIT WINDOW 'Cannot create an output file; press a key to exit'
	CANCEL
ENDIF

*!*   
STORE GETOBJECT([book3.xls]) TO oExcel
oExcel.Worksheets(1).ACTIVATE
oExcel.Worksheets(1).Cells(1,1)
oExcel = oExcel.Worksheets(1)

*!*    Start
m.lFound = oExcel.Cells.FIND("Start",,xlComments)
IF !ISNULL(m.lFound)
	m.cStart = m.lFound.Address(.T.,.T.,xlR1C1)
ENDIF
*!*    End
m.lFound = oExcel.Cells.FIND("End",,xlComments)
IF !ISNULL(m.lFound)
	m.cEnd = m.lFound.Address(.T.,.T.,xlR1C1)
ENDIF
*!*    FixRow
m.lFound = oExcel.Cells.FIND("FixRow",,xlComments)
IF !ISNULL(m.lFound)
	m.cFixedRow = m.lFound.Address(.T.,.T.,xlR1C1)
ELSE
	m.cFixedRow = 0
ENDIF
*!*    FixCol
m.lFound = oExcel.Cells.FIND("FixCol",,xlComments)
IF !ISNULL(m.lFound)
	m.cFixedCol = m.lFound.Address(.T.,.T.,xlR1C1)
ELSE
	m.cFixedCol = []
ENDIF

*    
m.nStartRow = VAL(SUBSTR(m.cStart,2,RAT([C],m.cStart)-2))
m.nStartCol = VAL(SUBSTR(m.cStart,RAT([C],m.cStart)+1))
m.nEndRow = VAL(SUBSTR(m.cEnd,2,RAT([C],m.cEnd)-2)) - m.nStartRow
m.nEndCol = VAL(SUBSTR(m.cEnd,RAT([C],m.cEnd)+1)) - m.nStartCol

*!*     
*!*   
m.nFixedRow = IIF(!EMPTY(m.cFixedRow), ;
	VAL(SUBSTR(m.cFixedRow, 2, RAT([C], m.cFixedRow)-2)), ;
	m.nStartRow - 1)
m.nFixedCol =IIF(!EMPTY(m.cFixedCol), ;
	VAL(SUBSTR(m.cFixedCol, RAT([C], m.cFixedCol)+1)), ;
	m.nStartCol - 1)

TEXT
WITH THIS
*!*  .   
	.MergeCells = 2
	.cols = <<m.nEndCol+1>>
	.ROWS = <<m.nEndRow+1>>
*!*      
	.FixedCols = <<m.nFixedCol +1 - m.nStartCol>>
	.FixedRows = <<m.nFixedRow+1 - m.nStartRow>>
ENDTEXT


*!*      Excel- 
*!*     FlexGrid
LOCAL ARRAY aCol(m.nEndCol+1), aRow(m.nEndRow+1)
FOR m.nCol = 0 TO m.nEndCol
	FOR m.nRow = 0 TO m.nEndRow
TEXT

*!*  <<m.nCol>>,  <<m.nRow>>
	.COL = <<m.nCol>>
	.ROW = <<m.nRow>>
ENDTEXT
		oCell = oExcel.Cells(m.nStartRow + m.nRow, m.nStartCol + m.nCol)
		IF oCell.MergeCells
			m.Address = oCell.MergeArea.Address(.T.,.T.,xlR1C1)
			m.Address1 = LEFT(m.Address,AT([:],m.Address)-1)
			m.Address2= RIGHT(m.Address,LEN(m.Address) - AT([:],m.Address))
			m.nStartTextRow = VAL(SUBSTR(m.Address1,2,RAT([C],m.Address1)-2))
			m.nStartTextCol = VAL(SUBSTR(m.Address1,RAT([C],m.Address1)+1))
			m.nStartTextRow1 = VAL(SUBSTR(m.Address2,2,RAT([C],m.Address2)-2))
			m.nStartTextCol1 = VAL(SUBSTR(m.Address2,RAT([C],m.Address2)+1))
			*!*   Merge    
			IF m.nStartTextRow = m.nStartTextRow1
				aRow(m.nRow+1) = .T.
			ENDIF
			IF m.nStartTextCol = m.nStartTextCol1
				aCol(m.nCol+1) = .T.
			ENDIF
TEXT
	.TEXT = <<ConVertType (oExcel.Cells(m.nStartTextRow, m.nStartTextCol).VALUE)>>
ENDTEXT
			SetCellStayle(oExcel.Cells(m.nStartTextRow, m.nStartTextCol))
		ELSE
TEXT
	.TEXT = <<ConVertType (oCell.VALUE) >>
ENDTEXT
		ENDIF
		SetCellStayle(oCell)
	NEXT m.nRow
NEXT m.nCol
FOR i = 1 TO ALEN(aCol)
TEXT
	.mergecol(<<i-1>>) = <<aCol(i)>>
ENDTEXT
NEXT i
FOR i = 1 TO ALEN(aRow)
TEXT
	.mergeRow(<<i-1>>) = <<aRow(i)>>
ENDTEXT
NEXT i

TEXT
ENDWITH
ENDTEXT

FCLOSE(_TEXT)
MODIFY FILE INIT.txt

*!*    Grid-e  
*!*  excel-y
PROCEDURE SetCellStayle(oActiveCell)
	WITH oActiveCell.FONT
TEXT
	.CellFontName = "<<.NAME>>"
	.CellFontSize = <<.SIZE>>
	.CellFontBold = <<.Bold>>
	.CellFontItalic = <<.Italic>>
	.CellFontStrikeThrough = <<.StrikeThrough>>
	.CellFontUnderline = <<IIF(.Underline = xlUnderlineStyleNone,.F.,.T.)>>
ENDTEXT
	ENDWITH
	WITH oActiveCell
		DO CASE
			CASE .HorizontalAlignment = xlLeft AND ;
					.VerticalAlignment = xlTop
				nCellAling = 0
			CASE .HorizontalAlignment = xlLeft AND ;
					.VerticalAlignment = xlCenter
				nCellAling = 1
			CASE .HorizontalAlignment = xlLeft AND ;
					.VerticalAlignment = xlBottom
				nCellAling = 2
			CASE .HorizontalAlignment = xlCenter AND ;
					.VerticalAlignment = xlTop
				nCellAling = 3
			CASE .HorizontalAlignment = xlCenter AND ;
					.VerticalAlignment = xlCenter
				nCellAling = 4
			CASE .HorizontalAlignment = xlCenter AND ;
					.VerticalAlignment = xlBottom
				nCellAling = 5
			CASE .HorizontalAlignment = xlRight AND ;
					.VerticalAlignment = xlTop
				nCellAling = 6
			CASE .HorizontalAlignment = xlRight AND ;
					.VerticalAlignment = xlCenter
				nCellAling = 7
			CASE .HorizontalAlignment = xlRight AND ;
					.VerticalAlignment = xlBottom
				nCellAling = 8
			OTHERWISE
				nCellAling = 9
		ENDCASE
TEXT
	.ColWidth(<<m.nCol>>) = <<.WIDTH * 0.35 * 57>>
	.ROWHEIGHT(<<m.nRow>>) = <<.HEIGHT * 0.35 * 57>>
ENDTEXT
		IF .Interior.ColorIndex = xlColorIndexNone
TEXT
	.CellBackColor = .CellBackColor
ENDTEXT
		ELSE
TEXT
	.CellBackColor = <<.Interior.COLOR>>
ENDTEXT
		ENDIF

		IF .FONT.ColorIndex = xlColorIndexNone
TEXT
	.CellForeColor = .CellForeColor
ENDTEXT
		ELSE
TEXT
	.CellForeColor = <<.FONT.COLOR>>
ENDTEXT
		ENDIF
TEXT
	.CellAlignment = <<nCellAling>>
ENDTEXT
	ENDWITH
ENDPROC

FUNCTION ConVertType (utext)
	DO CASE
		CASE VARTYPE(m.utext)=[C]
			m.cText = ["]+m.utext+["]
		CASE INLIST(VARTYPE(m.utext),[N],[Y])
			m.cText = m.utext
		CASE VARTYPE(m.utext)=[D]
			m.cText = ["]+DTOC(m.utext)+["]
		CASE VARTYPE(m.utext)=[T]
			m.cText = ["]+TTOC(m.utext)+["]
		CASE VARTYPE(m.utext)=[X]
			m.cText = [""]
		OTHERWISE
			m.cText = m.utext
	ENDCASE
	RETURN cText
ENDFUNC
